#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/time.h>
#include <time.h>
#include <sys/select.h>
#include <unistd.h>
#include <sched.h>
#include <SDL/SDL.h>
#include "fmdds.h"

/* Image parameters */
int WIDTH = 2048;
int HEIGHT = 2048;
int PIXELS;
int HTOTAL = 0;
int VTOTAL = 0;

/* Signal parameters */
#define DELTA_FREQ 75000    /* In Hz */
#define SIGNAL_SAMPLES 30000   /* In Hz */
int CARRIER = 35000000;
int SAMPLE_RATE = 73000000;
int CARRIER_PER_SIGNAL;
double FRAME_RATE;
int FRAME_TICKS; /* In ms */
int FRAME_US; /* In ms */

/* Misc */
char *FILENAME = "tst.mp3";
#define BUFFER_SAMPLES_SHIFT 16
#define BUFFER_SAMPLES (1<<BUFFER_SAMPLES_SHIFT)
#define BUFFER_SAMPLES_MASK ((1<<BUFFER_SAMPLES_SHIFT)-1)

volatile double *freqbuf; 
volatile double *slopebuf; 
volatile long int writepos, readpos;
volatile int theend;

/* The signal generation and some helpers are imported from here */
#include "fm.h"

int writelen(int maxlen)
{
    int rp = readpos;
    int len;

    if (rp < writepos)
	rp += BUFFER_SAMPLES;
    len = rp - writepos;
    /*
    printf("readpos:%d, writepos:%d, rp:%d, len:%d\n", readpos, writepos, 
	   rp, len);
    */
    return len > maxlen ? maxlen : len;
}

int baseband_mod(void *thing)
{
    FILE *pipe;
    int len;
    int i;
    double freq;
    char cmd[256];
    double min = 100000000;
    double max = -1;
    Sint16 tmpbuf[1024];
    double lastfreq = CARRIER;
    long int lastwritepos = writepos;
    double slope;
    
    theend = 0;

    sprintf(cmd, "sox %s -r %d -c 1 -s -2 -t raw -", FILENAME,SIGNAL_SAMPLES); 
    pipe = popen(cmd, "r");
    while (!theend) {
	len = writelen(1024);
	if (len > 0) {
	    len = fread(tmpbuf, 2, len, pipe);
	    theend = len == 0;
	    for (i=0; i < len; i++) {
		/* Modulate and buffer the sample */
		lastfreq = modulate_sample(lastwritepos, lastfreq, 
					   tmpbuf[i]/32767.0);
		lastwritepos = writepos++;
		writepos %= BUFFER_SAMPLES;
	    }
	} else {
	    usleep(100000);
	}
    }
    printf("Yo, like end of line");
    exit(1);
}

#include "fmmain.h"
